/*
 *
 * Author:  Hans Petter Holen, USIT - University of Oslo
 *          Anders Ellefsrud,  Ifi  - University of Oslo
 */

/*
 * $Header: /local/src/CVSROOT/X11/halo/halo.c,v 1.35 1995/02/08 18:12:28 kjetilho Exp $
 * $Log: halo.c,v $
 * Revision 1.35  1995/02/08  18:12:28  kjetilho
 * La inn sttte for "reaper" p SGI (endsession)
 *
 * Revision 1.34  1994/06/29  14:58:09  anders
 * *** empty log message ***
 *
 * Revision 1.33  1994/06/29  14:56:26  anders
 * Lukk alle fildescriptorene, det finner xdm-implementasjoner som
 * glemmer  lukke enkelte fd# fr vi fr dem.
 *
 * Revision 1.32  1994/03/07  09:50:24  anders
 * patcher fra Morteh Hanshaugen for hpux og aix
 *
 * Revision 1.31  1994/01/30  00:10:05  karlo
 * Fiksa bug med bruk av minne etter frigjering - fungerer p Linux
 *
 * Revision 1.30  1993/09/22  08:51:57  anders
 * Portet til sgi irix5
 *
 * Revision 1.29  1993/04/02  09:07:49  anders
 * terminateParent kode
 *
 * Revision 1.28  1993/04/01  13:39:21  anders
 * Strip og frontstrip av kommando-ressursene
 *
 * Revision 1.27  1993/03/05  12:34:25  anders
 * Lagt inn noen kall p} signal() for } unng} problemer med sysV boxer.
 *
 * Revision 1.26  1993/01/18  13:01:30  anders
 * Tatt vekk noen debug ting
 *
 * Revision 1.25  1992/12/15  18:00:21  anders
 * Converted to Xt program
 *
 */

#ifndef lint
static char    *rcsid = "$Id: halo.c,v 1.35 1995/02/08 18:12:28 kjetilho Exp $";

#endif

#include <stdio.h>
#include <sys/wait.h>
#include <pwd.h>
#include <signal.h>
#include <sys/param.h>
#ifdef sun
/* #include <vfork.h> 1994-03-06, meh: Fungerte ikke under solaris ;-) */
#include <unistd.h>
#endif
/* 1994-03-06, meh: Gjelder ikke bare sgi, ogs} aix. */
#if defined(__sgi) || defined(AIXV3)
#define FORK fork
#else
#define FORK vfork
#endif
#include <limits.h>
#include <X11/Intrinsic.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>

#ifdef hpux
/*
 * getdtablesize ()
 *
 * Returns the maximum number of file descriptors allowed.
 */

#include <unistd.h>

int getdtablesize ()
{
        return(sysconf(_SC_OPEN_MAX));
}
#endif

char           *ProgramName;

extern char    *realloc ();
extern char    *malloc ();
extern void     exit ();
extern FILE *fdopen();

extern char   **split ();
extern char   **join ();
extern char   **lremove ();
extern void     savechild ();
extern char    *findchild ();
extern int      nochilds ();
extern void     childremove ();
extern char *getlistofchilds();
void            print_resources ();
void            load_resources ();
void		child_return_resources();
void restart_as_indicated();

void propertysignal ();
void            cleanup ();
void            run ();


static char   **waitfor;	       /* List of jobs we want to wait for */
static char   **terminatecmds;	       /* Commands to run whan logging out */
static char          **syscommands;
static char          **cmds;
static char          **notcmds;
static char          **addcmds;
static Atom halo_childs;
static Display *dpy;
static void kill_parent();

int             verbose;
unsigned        delay = 1;
int		loggingout = 0;		/* Flag indicating we are in the logout phase */
char            halopid[MAXPATHLEN];   /* Name of the halo pid file */
Widget toplevel;

char          **Argv;
int             Argc;

typedef struct {
	int             delay;
	Boolean         verbose;
	Boolean         waitForAll;
	Boolean 	terminateParent;
	char           *windowManager;
	char           *waitFor;
	char           *sysCmds;
	char           *cmds;
	char           *notCmds;
	char           *addCmds;
	char           *terminateCmds;

}               app_resourceRec, *app_res;

app_resourceRec app_resources;

static XtResource resources[] = {
	{"windowManager", "WindowManager", XtRString, sizeof (char *),
	XtOffset (app_res, windowManager), XtRString, (caddr_t) NULL},
	{"waitFor", "WaitFor", XtRString, sizeof (char *),
	XtOffset (app_res, waitFor), XtRString, (caddr_t) NULL},
	{"delay", "Delay", XtRInt, sizeof (int),
	XtOffset (app_res, delay), XtRInt, (caddr_t) NULL},
	{"verbose", "Verbose", XtRBoolean, sizeof (Boolean),
	XtOffset (app_res, verbose), XtRBoolean, (caddr_t) NULL},
	{"waitForAll", "WaitForAll", XtRBoolean, sizeof (Boolean),
	XtOffset (app_res, waitForAll), XtRBoolean, (caddr_t) NULL},
	{"terminateParent", "terminateParent", XtRBoolean, sizeof (Boolean),
	XtOffset (app_res, terminateParent), XtRBoolean, (caddr_t) NULL},
	{"sysCmds", "SysCmds", XtRString, sizeof (char *),
	XtOffset (app_res, sysCmds), XtRString, (caddr_t) NULL},
	{"cmds", "Cmds", XtRString, sizeof (char *),
	XtOffset (app_res, cmds), XtRString, (caddr_t) NULL},
	{"notCmds", "NotCmds", XtRString, sizeof (char *),
	XtOffset (app_res, notCmds), XtRString, (caddr_t) NULL},
	{"addCmds", "AddCmds", XtRString, sizeof (char *),
	XtOffset (app_res, addCmds), XtRString, (caddr_t) NULL},
	{"terminateCmds", "TerminateCmds", XtRString, sizeof (char *),
	XtOffset (app_res, terminateCmds), XtRString, (caddr_t) NULL},
};

static XrmOptionDescRec options[] = {
	{"-verbose", "*verbose", XrmoptionNoArg, (caddr_t) "on"},
};

static void
Usage ()
{
	static char    *help_message[] = {
		"where options include:",
		"    -display host:dpy              X server to contact",
		"    -verbose",
	NULL};
	char          **cpp;

	fprintf (stderr, "usage:  halo [-options ...]\n");
	for (cpp = help_message; *cpp; cpp++) {
		fprintf (stderr, "%s\n", *cpp);
	}
	fprintf (stderr, "\n");
	exit (1);
}

/* 1994-03-06, meh: Ikke deklarer strdup for HP. */
/* 1995-01-26, kjetilho: Ditto for SGI. */
#if ! defined(_BSD_SOURCE) && ! defined(hpux) && ! defined(sgi)
char           *
strdup (s)
	char	       *s;
{
	char           *r = malloc ((unsigned int)strlen (s) + 1);

	if (r)
		strcpy (r, s);
	return r;
}
#endif

int
main (argc, argv)
	int             argc;
	char          **argv;
{
	int		i;
	void            hupped ();
	void            intr ();
	void            start_logout ();
	void		dead_child();
	void            savepid ();

	Atom halo_signal;
	Atom sgi_reaper;
	Window root;
	XEvent event;

	signal (SIGHUP, SIG_IGN);
#ifdef __hpux
	if (setvbuf (stdout, NULL, _IOLBF, BUFSIZ) != 0)
		perror ("setvbuf failed"), exit (1);
#else
	setlinebuf (stdout);
#endif

#ifdef DEBUG
	malloc_debug (2);
#endif

	ProgramName = argv[0];
	Argc = argc;
	Argv = argv;

	/* Close open junk-diescriptors */
	for (i=3;i<=getdtablesize(); i++)
		close (i);

	toplevel = XtInitialize ("halo", "Halo", NULL, 0,
				 &Argc, Argv);

	if (argc == 2 && strcmp (argv[1], "-Slave") == 0) {
		/* Started in slave mode (from */
		/* load_resources()) */
		child_return_resources();
		exit(0);
	}

	savepid ();

	load_resources ();

	dpy = XtDisplay(toplevel);
	root = DefaultRootWindow (dpy);
	halo_signal = XInternAtom (dpy, "HALO_SIGNAL", False);
	halo_childs = XInternAtom (dpy, "HALO_CHILDS", False);
	sgi_reaper =  XInternAtom (dpy, "_SGI_SESSION_PROPERTY", False);

	if (app_resources.windowManager && *app_resources.windowManager)
		run (split ('\1', app_resources.windowManager));
	run (lremove (join (syscommands, cmds), notcmds));
	run (addcmds);

	signal (SIGHUP, hupped);
	signal (SIGINT, intr);
	signal (SIGTERM, intr);
	signal (SIGCHLD, dead_child);

	XSelectInput (dpy, root, PropertyChangeMask);

	for (;;) {
		XtNextEvent (&event);
		if (event.type == PropertyNotify &&
		    event.xproperty.window == root) {
		    if (event.xproperty.atom == halo_signal) {
			    load_resources();
			    restart_as_indicated();
			    continue;
		    } else if (event.xproperty.atom == sgi_reaper) {
			    if (event.xproperty.state == PropertyDelete)
				start_logout ();
			    continue;
		    }
		}
		XtDispatchEvent (&event);
	}
}

/* exec a list of commands */
void
run (cmds)
	char          **cmds;
{
	int             pid;
	static char    *command = 0;
	if (!cmds)
		return;

	for (; *cmds; cmds++) {
#ifdef DEBUG
		malloc_verify ();
#endif
		command = command ?
			realloc (command, (unsigned) strlen (*cmds) + 6) :
			malloc ((unsigned) strlen (*cmds) + 6);
		sprintf (command, "exec %s", *cmds);
		switch (pid = fork ()) {
		case -1:
			perror ("fork");
			exit (1);
		case 0:
			execl ("/bin/sh", "sh", "-c", command, (char *) 0);
			perror ("exec /bin/sh failed");
			exit (1);
		default:
			break;
		}
		if (verbose)
			printf ("%s: Run \"%s\" (%d)\n", ProgramName, *cmds, pid);
		savechild (pid, strdup (*cmds));
#ifdef DEBUG
		malloc_verify ();
#endif
		sleep (delay);
	}
	propertysignal (getlistofchilds());
}

void
dead_child ()
{
	int             sp;
	int             pid;
	char           *chname;
	int		waiting;
	int             checkwait ();
	void            start_logout ();

	while ((pid = wait3 (&sp, WNOHANG, NULL)) > 0) {
		if (pid == -1)
			perror ("halo: wait"), exit (1);
		chname = findchild (pid);
		if (chname) {
			if (verbose)
				printf ("%s: Process \"%s\" (%d) terminated\n",
					ProgramName, chname, pid);
			waiting = checkwait (chname);
			propertysignal (getlistofchilds());
			childremove (pid);
			XFlush (dpy);
			if (app_resources.waitForAll ? *waitfor == 0 || nochilds () : waiting) {
			        start_logout ();
			}
			if (loggingout && nochilds()) {
				if (verbose)
					printf ("%s: All major processes finished, logging out\n", ProgramName);
				if (app_resources.terminateParent)
					kill_parent();
				exit (0);
			}
		}
	}
	signal (SIGCHLD, dead_child);
}


/* Remove the child from the wait-list if it is there */
/* Returns true if this is a child we wanted to wait for */
int
checkwait (chname)
	char           *chname;
{
	char          **pp;

	for (pp = waitfor; *pp; pp++) {
		if (strcmp (*pp, chname) == 0) {
			if (verbose)
				printf ("%s: Process \"%s\" on the waitFor list finished\n",
					ProgramName, chname);
			while (*pp = pp[1])
				pp++;
			return 1;
		}
	}
	return 0;
}

/* SIGHUP handler */
/* When this signal is received, halo will re-read its */
/* resources, kill off any processes not in the resources */
/* anymore and start any new one */
void
hupped ()
{
	puts ("Received SIGHUP, rereading resources");

	load_resources ();
	restart_as_indicated();
	signal (SIGHUP, hupped);
}

/* Checks for changed resources, which maybe */
/* indicate that some childs should be killed down or */
/* started up. */
void
restart_as_indicated()
{
	static char    *list[1024];
	char          **pp;
	void		killunnamedchilds ();
	char          **cp;
	char          **lp;
	lp = list;
	if (app_resources.windowManager && *app_resources.windowManager)
		*lp++ = app_resources.windowManager;

	cmds = (lremove (join (syscommands, cmds), notcmds));
	for (cp = cmds; *cp; cp++)
		*lp++ = *cp;

	if (addcmds)
		for (cp = addcmds; *cp; cp++)
			*lp++ = *cp;
	*lp = 0;		       /* 0 terminate list */

	killunnamedchilds ((char **)list); /* Kill all childs */
	/* not found in "list" */
	/* Start all commands in "list" which is not */
	/* currently running */
	for (lp = list; *lp; lp++)
		if (!namechild (*lp))
			run (split ('\1', *lp));
}

void
intr ()
{
	void            cleanup ();

	puts ("Received SIGINT or SIGTERM, cleaning up");
	cleanup ();
	signal (SIGINT, intr);
	signal (SIGTERM, intr);
}

void
start_logout ()
{
        if (!loggingout) {
	        if (verbose)
		        printf ("%s: Logging out\n", ProgramName);
		cleanup ();
	}
}

void 
cleanup ()
{
	int             pid;
	char           *chname;
	int             sp;
	void            logout_timeout ();
	void            removepidfile ();
	void		killallchilds();

	killallchilds ();
	removepidfile ();
	run (terminatecmds);
	signal (SIGALRM, logout_timeout);
	loggingout = 1;
	alarm (30);		       /* Give terminatecmds some time to
				        * work */
}


void
logout_timeout ()
{
	void		killallchilds();

	killallchilds ();
	printf ("%s: Terminated\n", ProgramName);
	if (app_resources.terminateParent)
		kill_parent();
	exit (0);
}

/* Terminate our parent, needed to HUP xdm @ ultrix */
static void
kill_parent ()
{
	int pid = getppid();
	if (verbose) 
		printf ("%s: Killing parent pid %d\n", ProgramName, pid);
	kill (pid, SIGTERM);
	sleep (2);
	kill (pid, SIGKILL);
}

void
propertysignal(string)
	unsigned char *string;
{

	XChangeProperty (dpy, DefaultRootWindow(dpy),
			 halo_childs, XA_STRING, 8,
			 PropModeReplace, string,
			 strlen((char *)string));
}

/* Save our pid for future use */
void
savepid ()
{
	FILE           *f;
	struct passwd  *p;

	p = getpwuid (getuid ());
	sprintf (halopid, "%s/.halopid", p->pw_dir);
	f = fopen (halopid, "w");
	fprintf (f, "%d\n", getpid ());
	fclose (f);
}

/* Remove the pid file if it contains our pid */
void
removepidfile ()
{
	char            buff[100];
	int             pid;
	int             mypid = getpid ();
	FILE           *f = fopen ("halopid", "r");

	if (!f)
		return;
	fgets (buff, 99, f);
	fclose (f);
	pid = atoi (buff);
	if (pid == mypid)
		unlink (halopid);
	else
		printf ("%s: ~/.halopid does not contain my pid (%d). It contains %d, ignored\n",
			ProgramName, mypid, pid);
}

/* This procedure forks (to awoid problems with */
/* initializeing Xt multiple times) and returns the */
/* relevant resources to the main program in the */
/* app_resources variable */
void
load_resources ()
{
	int             fd[2];
	char          **pp;
	FILE *f;

	if (pipe (fd) == -1)
		perror ("pipe"), exit (1);
	if (FORK() == 0) {	       /* Child */
		close (fd[0]);
		close (1);
		dup (fd[1]);
		execlp(Argv[0], Argv[0], "-Slave", 0);
		perror("exec halo -Slave");
	} else {		       /* parent */
#define BUFLEN 1024
		char            buff[BUFLEN];
		char	       *p;

		close (fd[1]);
		f = fdopen (fd[0], "r");
#ifdef __STDC__
#define FOUNDS(res) if (strncmp (buff, #res ": ", strlen (#res)+2) == 0) { \
			if (app_resources.res) free (app_resources.res); \
			app_resources.res = strdup (strchr (buff, ':') + 2); }
#define FOUNDI(res) if (strncmp (buff, #res ": ", strlen (#res)+2) == 0) { \
			app_resources.res = atoi (strchr (buff, ':') + 2); }
#else
#define FOUNDS(res) if (strncmp (buff, "res: ", strlen ("res")+2) == 0) { \
			if (app_resources.res) free (app_resources.res); \
			app_resources.res = strdup (strchr (buff, ':') + 2); }
#define FOUNDI(res) if (strncmp (buff, "res: ", strlen ("res")+2) == 0) { \
			app_resources.res = atoi (strchr (buff, ':') + 2); }
#endif

		while (fgets (buff, BUFLEN, f)) {
			p = strchr (buff, '\n');
			if (p) 
				*p = 0;
			else
				fprintf (stderr, "Line to long: %s\n", buff);
			FOUNDS (windowManager)
			else FOUNDS (waitFor)
			else FOUNDI (delay)
			else FOUNDS (sysCmds)
			else FOUNDS (cmds)
			else FOUNDS (notCmds)
			else FOUNDS (addCmds)
			else FOUNDI (verbose)
			else FOUNDI (terminateParent)
			else FOUNDI (waitForAll)
			else FOUNDS (terminateCmds)
			else printf ("%s: Unrecognized response from resource database: %s\n",
					ProgramName, buff);
		}
#undef FOUNDS
#undef FOUNDI
#undef BUFLEN
	}
	verbose = app_resources.verbose;

	if (verbose)
		print_resources ();

	syscommands = split (';', app_resources.sysCmds);
	cmds = split (';', app_resources.cmds);
	notcmds = split (';', app_resources.notCmds);
	addcmds = split (';', app_resources.addCmds);
	waitfor = split (';', app_resources.waitFor);

	if (waitfor)
		for (pp = waitfor; *pp; pp++) {
			if (strcmp (*pp, "WINDOW_MANAGER") == 0)
				*pp = app_resources.windowManager;
		}

	terminatecmds = split (';', app_resources.terminateCmds);
	delay = app_resources.delay;
}

void
print_resources ()
{
	puts ("HALO - UiO X configuration utility");
	printf ("%s: halo.windowManager: %s\n", ProgramName, app_resources.windowManager);
	printf ("%s: halo.waitFor: %s\n", ProgramName, app_resources.waitFor);
	printf ("%s: halo.delay: %d\n", ProgramName, app_resources.delay);
	printf ("%s: halo.sysCmds: %s\n", ProgramName, app_resources.sysCmds);
	printf ("%s: halo.cmds: %s\n", ProgramName, app_resources.cmds);	/* */
	printf ("%s: halo.notCmds: %s\n", ProgramName, app_resources.notCmds);
	printf ("%s: halo.addCmds: %s\n", ProgramName, app_resources.addCmds);
	printf ("%s: halo.verbose: %d\n", ProgramName, app_resources.verbose);
	printf ("%s: halo.waitForAll: %d\n", ProgramName, app_resources.waitForAll);
	printf ("%s: halo.terminateCmds: %s\n", ProgramName, app_resources.terminateCmds);
	printf ("%s: halo.terminateParent: %d\n", ProgramName, app_resources.terminateParent);
}

/* Run in a subprocess (started from load_resources()), */
/* prints resources to stdout, which the parent picks up in */
/* load_resources() */ 
void
child_return_resources()
{
	XtGetApplicationResources (toplevel, (caddr_t) & app_resources,
				   resources,
				   XtNumber (resources), 0, 0);
#ifdef __STDC__
#define RETURNS(res) printf (#res ": %s\n", app_resources.res ? app_resources.res : "")
#define RETURNI(res) printf (#res ": %d\n", app_resources.res)
#else
#define RETURNS(res) printf ("res: %s\n", app_resources.res ? app_resources.res : "")
#define RETURNI(res) printf ("res: %d\n", app_resources.res)
#endif
	RETURNS (windowManager);
	RETURNS (waitFor);
	RETURNI (delay);
	RETURNS (sysCmds);
	RETURNS (cmds);
	RETURNS (notCmds);
	RETURNS (addCmds);
	RETURNI (verbose);
	RETURNI (terminateParent);
	RETURNI (waitForAll);
	RETURNS (terminateCmds);
#undef RETURNS
#undef RETURNI
	XtCloseDisplay (XtDisplay (toplevel));
}
