.TH HALO 1 "1/11/96" "X Version 11"
.SH NAME
halo - start and manage X programs (session manager light)
.SH SYNOPSIS
.B halo
[-\fItoolkitoption\fP ...] [-option ...]
.SH DESCRIPTION
The program starts the window manager, some initial comands
and waits for one or more of its children before it
terminates. The program is typically started by xdm from
Xsession (or .xsession). When the configured child exits
Halo kills the rest of its children before exiting.

.SH OPTIONS
.I Halo
accepts all of the standard X Toolkit command line options along with the
additional options listed below:
.PP
.B \-verbose 
causes halo to print what it is doing.

.SH X DEFAULTS
The application class name is 
.I Halo.
.PP
.TP 8
.B windowManager (class\fB WindowManager)
This resource specifies the Window manager the user wishes
to run.
.TP 8
.B waitFor (class\fB WaitFor)
Specifies which of its children halo should wait for before
exiting.  Excact match is performed. The special token
WINDOW_MANAGER means wait for the window manager.
.TP 8
.B waitForAll (class\fB WaitForAll)
If set to
.B true,
all programs in the
.B waitFor
list have to be terminated before you will be logged out.
It it is set to
.B false,
you will be logged out if only one (any one) of the
programs in the
.B waitFor
list terminates.
.TP 8
.B Delay (class\fB delay)
Delay specified in seconds to sleep between starting each
child.
.TP 8
.B cmds (class\fB cmds)
A ; separated list of sh commands to start. This resource
is typicaly default configured to some minimal set of
programs.
.TP 8
.B notCmds (class\fB NotCmds)
A ; separated list of programs in cmds, addCmds or sysCmds
you do not wish to start. Excact match is performed so xfoo
will not match xfoo -name bar.
.TP 8
.B addCmds (class\fB AddCmds)
A ; separated list of commands you wish to start in
addition to what your system manager have globaly
configured in cmds.
.TP 8
.B sysCmds (class\fB SysCmds)
A ; separated list of sh commands to start. This resource
is typicaly used by your System Manager to start programs
you ought to run. Users should not modify this resource.
(but rather use the notCmds resouce if the dislike some of
the programs started from here.)
.TP 8
.B terminateCmds (class\fB TerminateCmds)
A ; separated list of commands you wish to run when you are
logging out. This commands are given 30 seconds to finish
before you are logged out.
.TP 8
.B verbose (class\fB Verbose)
Same as -verbose. Causes halo to print what it is doing.
.SH SIGNALS
The resources will be re-read, removed programs killed
and new programs started when 
.B halo
receives the HUP signal.
.PP
All started processes will be killed before 
.B halo
terminates on receipt of the INT or TERM signals.
.SH BUGS
(or features)
.PP
All program are executed with the command
.br
	sh -c 'exec program'
.br
which means that contructions like 
.br
	a && b
.br
cannot be used as 
.I program.
This can be fixed with resources like this
.br
  halo.windowManager: sh -c 'xhost +`hostname` && exec mwm'
.PP
There is no way to put a ; in a command.
.PP
Only single line resources are supported.
.SH AUTHOR
Hans Petter Holen, USIT - University of Oslo,
.br
Anders Ellefrud - Ifi - University of Oslo,
.br
Lars Haakedal - USIT - University of Oslo,
.br
Odd Einar Aurbakken - USIT  - University of Oslo.
