/*
 *
 * Author: Anders Ellefsrud,  Ifi  - University of Oslo
 *
 */

/*
 * $Header: /local/src/CVSROOT/X11/halo/list.c,v 1.5 1993/04/01 13:39:24 anders Exp $
 * $Log: list.c,v $
 * Revision 1.5  1993/04/01  13:39:24  anders
 * Strip og frontstrip av kommando-ressursene
 *
 * Revision 1.4  1992/11/19  12:04:46  anders
 * Ymse debugging
 *
 */

#ifndef lint
static char    *rcsid = "$Id: list.c,v 1.5 1993/04/01 13:39:24 anders Exp $";

#endif

#include <string.h>
extern char    *realloc ();
extern char    *malloc ();

char          **
split (del, string)
	char            del;
	char           *string;
{
	char          **cmds;
	char           *p;
	int             n = 0;

#ifdef DEBUG
	malloc_verify ();
#endif
	if (!string)
		return (char **) 0;

	cmds = (char **) malloc (sizeof (char *));
	while (*string && (p = strchr (string, del))) {
		while (isspace (*string))
			string++;
		cmds[n++] = string;
		string = p + 1;
		p--;
		while (isspace (*p))
			p--;
		*++p = 0;
		cmds = (char **) realloc ((char *) cmds, (unsigned) (n + 1) * sizeof (char *));
	}
	if (*string) {
		while (isspace (*string))
			string++;
		cmds[n++] = string;
		for (p = string; *p; p++)
			;
		p--;
		while (isspace (*p))
			p--;
		*++p = 0;
		cmds = (char **) realloc ((char *) cmds, (unsigned) (n + 1) * sizeof (char *));
	}
	cmds[n] = 0;
#ifdef DEBUG
	malloc_verify ();
#endif
	return cmds;
}

/* Join the arrays a & b */
char          **
join (a, b)
	char          **a;
	char          **b;
{
	char          **p;
	unsigned int    n;
	int             alen;

#ifdef DEBUG
	malloc_verify ();
#endif
	if (!a)
		return b;

	for (n = 0, p = a; *p++; n++);
	alen = n;
	for (p = b; *p++; n++);
	a = (char **) realloc ((char *) a, (n + 1) * sizeof (char *));
	p = a + alen;
	while (*b)
		*p++ = *b++;
	*p = 0;
#ifdef DEBUG
	malloc_verify ();
#endif
	return a;
}

/* remove all entries in e from the a list */
char          **
lremove (a, e)
	char          **a;
	char          **e;
{
	int             n;
	int             i;
	char          **p;

	if (!a || !e)
		return a;

#ifdef DEBUG
	malloc_verify ();
#endif
	for (n = 0, p = a; *p; p++)
		n++;
	for (; *e; e++) {
		for (i = 0; i < n; i++)
			if (a[i] && strcmp (a[i], *e) == 0)
				a[i] = 0;
	}
	for (p = e = a; n; n--)
		if (*p++)
			*e++ = p[-1];
	*e = 0;
#ifdef DEBUG
	malloc_verify ();
#endif
	return a;
}
